#include <stdlib.h>
#include "stuff.h"
#include <stdio.h>
#include "list.h"
#include <malloc.h>
#include <string.h>
uint32 List::G_num=0;

List::List(int is){
    list_arr=(void**)malloc(sizeof(void*)*is);
    init_size=is;
    table_size=is;
    last_pos=0;
    num=0;
    }

List::~List()
    {
    uint i=0;
    for(i=0;i<num;i++)free(list_arr[i]);
    if(list_arr!=NULL)free(list_arr);
    list_arr=NULL;
    num=0;
    last_pos=0;
    }

int List::DestroyAll()
    {
    uint i=0;
    for(i=0;i<num;i++)free(list_arr[i]);
    num=0;
    last_pos=0;
    return 0;
    }

void* List::FindStringInList(char* str,int d)
    {
    void* ptr;
    int i;
    if(!num)return NULL;
    for(i=0;i<num;i++){
                      ptr=(void*)list_arr[i];
                      if(!strcmp(*(char**)((char*)ptr+d),str))break;
                      }
    if(i==num)return NULL;
    else return ptr;
    }

void List::Xchg(int a,int b)
    {
    void *tmp;
    if((a>=num)||(b>=num))return;
    tmp=list_arr[a];
    list_arr[a]=list_arr[b];
    list_arr[b]=tmp;
    return;
    }

int List::Del(int index)
    {
    long len;
    void* src,*dst;
    if(!num)return 0;
    if(index>=num)return -1;
    free(list_arr[index]);
    src=&list_arr[index+1];
    dst=&list_arr[index];
    len=(num-index-1)*sizeof(void*);
    memmove(dst,src,len);
    num--;
    G_num--;
    return 0;
    }

void *List::Get(int index)
    {
    if((unsigned int)index>=(unsigned int)num)return NULL;
    return list_arr[index];
    }

uint32 List::GetGlobalNum(void)
   {
   return G_num;
   }

void *List::GetNext(int init)
     {
     if(init){last_pos=0;return NULL;}
     return Get(last_pos++);
     }

int List::Add(void *el,unsigned int index)
    {
    void *src,*dst;
    long len;
    if(index==-1)index=num;
    else if(index>num)return NULL;
    num++;G_num++;
    if(num>table_size){
                      list_arr=(void**)realloc(list_arr,sizeof(void*)*(init_size+table_size));
                      if(list_arr==NULL)return -1;
                      table_size+=init_size;
                      }
     len=(num-index-1)*sizeof(void*);
     src=&list_arr[index];
     dst=&list_arr[index+1];
     memmove(dst,src,len);
     list_arr[index]=el;
     return 0;
     }
int List::QSort(int (*compar)(const void*, const void*))
{
qsort(list_arr,num,sizeof(void*),compar);
return 0;
}