#include <string.h>
#include <stdio.h>
#include "append.h"
#include "stuff.h"
#include "info.h"
uint32 method=1;

#define NEW_SECTION_M "ns"
#define RESIZE_SECTION_M "rs"
#define WRITE_ACCSESS_M "rws"
#define NULL_RELOC_M "rn"
#define CHECK_SUM_M "cs"
#define NO_CHANGE_EP_M "nep"
#define EXPORTS_M "exp"
#define IMPORTS_M "imp"
#define REMOVE_M  "rl"
#define PRINT_M   "i"
#define PRINT_EXTEND_M "ei"
#define HELP_M "help"
char* SwitchParameter=NULL;
char *imp=NULL;
char *exp=NULL;

int stricmp_s(char* str1,char* str2,int equ=0)
	{
	char buff[256];
	int i;
	SwitchParameter=NULL;
	char *ptr=str1;
	if(!equ)return stricmp(str1,str2);
	i=strcspn(str1,"=");
	ptr+=i;
	if(i>=255)return -1;
	memcpy(buff,str1,i);
	buff[i]=0;
	if(!(*ptr))return stricmp(str1,str2);
	ptr++;
	SwitchParameter=ptr;
	return strcmp(buff,str2);	
	}
void SetSwitch (char *sw)
{
	uint i=0;
	if(!stricmp(&sw[1],NEW_SECTION_M))method|=1;
	else if(!stricmp_s(&sw[1],RESIZE_SECTION_M))method&=0xfffffffe;
	else if(!stricmp_s(&sw[1],WRITE_ACCSESS_M))method|=0x2;
	else if(!stricmp_s(&sw[1],NULL_RELOC_M))method|=0x4;
	else if(!stricmp_s(&sw[1],CHECK_SUM_M))method|=0x8;
	else if(!stricmp_s(&sw[1],NO_CHANGE_EP_M))method|=0x10;
	else if(!stricmp_s(&sw[1],EXPORTS_M,1)){method|=0x20;exp=SwitchParameter;}
	else if(!stricmp_s(&sw[1],IMPORTS_M,1)){method|=0x40;imp=SwitchParameter;}
	else if(!stricmp_s(&sw[1],REMOVE_M))method|=0x80;
	else if(!stricmp_s(&sw[1],PRINT_M))method|=0x100;
	else if(!stricmp_s(&sw[1],PRINT_EXTEND_M))method|=0x300;
	else if(!stricmp_s(&sw[1],HELP_M))method|=0x400;
    else printf ("Unknown switch '%s'\n",&sw[1]);
}
void ShowHelp();

int main(int argc,char **argv)
{
char *source=NULL;
char *target=NULL;
printf("\t\t+--V1.0--------------------------+\n"\
	   "\t\t|(c)   Melancholy Coding 2000     |\n"\
       "\t\t|            PE Appender          |\n"\
       "\t\t|Written by Gloomy aka Peter Kosyh|\n"\
	   "\t\t+---------------------------------+\n"\
	   "\t\t|       2:5020/931.255@Fido.Net   |\n"\
	   "\t\t|       mailto:peter_k@vivos.ru   |\n"\
       "\t\t+---------------------------------+\n");
if(argc<2){
printf(
"Use this:\n"\
"      peappend target.exe [source.bin] [options]\n"\
"Options are:\n");
printf(
"      [/%s|/%s][/%s][/%s][/%s][/%s][/%s][/%s][/%s][/%s|/%s][/%s]\n\n",NEW_SECTION_M,RESIZE_SECTION_M,WRITE_ACCSESS_M,NULL_RELOC_M,NO_CHANGE_EP_M,CHECK_SUM_M,EXPORTS_M,IMPORTS_M,REMOVE_M,PRINT_M,PRINT_EXTEND_M,HELP_M);
return 1;
          } 

for (uint i=1;i<argc;i++)
	{
		if(argv[i][0]=='/'||argv[i][0]=='-')SetSwitch(argv[i]);

		else {
			if(!target)target=argv[i];
			else if(!source)source=argv[i];
			else {
				printf ("Extra parameter!\n");
				return 1;
				}
		}
		if(method&0x400){ShowHelp();return 1;}
	}

if (!target){printf ("No target file\n");return 1;}
if ((!source)&(!(method&0x3ee))){
		printf ("No task specified\n");return 1;
		}
if (!imp)imp="imports.inc";
if (!exp)exp="exports.inc";

if(source)printf(" * Appending '%s' to '%s'...\n",target,source);
else printf(" * Working with '%s'...\n",target);
if(method&0x100){
		if(PrintInfo(target,method&0x200)){
                          printf (" * Failed\n");
                          return 1;
				}
		}
if(AppendToPe(target,source,imp,exp,method)){
                          printf (" * Failed\n");
                          return 1;
                               } 
else printf(" * Successed...\n");
if(method&0x8){
		printf(" * Fixing checksum...");
		if(FixCheckSum(target)!=0){
                          printf (" * Failed\n");
                          return 1;
				}
		}
return 0;
}
void ShowHelp()
{
printf("Options:\n\t/%s\t- Create new section  (source append to the new section\n "\
			   "\t/%s\t- Resize last section (source append in to the last section)\n"\
			   "\t/%s\t- Do all sections r/w (source can write in all sections)\n"\
			   "\t/%s\t- RELOCS RVA = NULL.  (source do all relocations)\n"\
                           "\t/%s\t- Do not change entry point. Do not add preinit code.\n"
                           "\t/%s\t- Compute checksum.                              \n"\
                           "\t/%s[=exports.inc]\t- Generate exports file.           \n"\
			   "\t/%s[=imports.inc]\t- Generate imports file.          \n"\
                           "\t/%s\t- Remove last section.                           \n"\
			   "\t/%s\t- Show header info.                              \n"\
                           "\t/%s\t- Show extend info. (sections&dir)               \n"\
                           "\t/%s\t- Show this help.                                \n",\
NEW_SECTION_M,RESIZE_SECTION_M,WRITE_ACCSESS_M,NULL_RELOC_M,NO_CHANGE_EP_M,CHECK_SUM_M,EXPORTS_M,IMPORTS_M,REMOVE_M,PRINT_M,PRINT_EXTEND_M,HELP_M);
}
